part of 'chat_detail_bloc.dart';

abstract class ChatDetailEvent extends Equatable {
  const ChatDetailEvent();

  @override
  List<Object> get props => [];
}

class ChatDetailInitialEvent extends ChatDetailEvent {
  ScrollController scrollController;
  TickerProvider tickerProvider;

  ChatDetailInitialEvent(this.scrollController, this.tickerProvider);
}

class ChatSendMessageEvent extends ChatDetailEvent {
  MessageType type;
  String text;
  File? image;

  Uint8List? imageData;
  String? imageExt;
  String? imageFileName;
  String? imageFileMime;
  int? assetFileDuration;

  ChatSendMessageEvent({
    required this.type,
    this.imageData,
    this.text = '',
    this.image,
    this.imageExt,
    this.imageFileMime,
    this.imageFileName,
    this.assetFileDuration,
  });
}

class ChatDetailLoadMoreMessagesEvent extends ChatDetailEvent {}

class ChatUpdateMessagesEvent extends ChatDetailEvent {}

class ChatDeleteMessagesEvent extends ChatDetailEvent {
  final int timestamp;
  ChatDeleteMessagesEvent(this.timestamp);
}

class ChatDetailDisposeEvent extends ChatDetailEvent {}

class ChatDetailReplyMessagesEvent extends ChatDetailEvent {
  Map<String, dynamic> repllyDoc;
  ChatDetailReplyMessagesEvent(this.repllyDoc);
}

class ChatDetailEditMessagesEvent extends ChatDetailEvent {
  Map<String, dynamic> editDoc;
  ChatDetailEditMessagesEvent(this.editDoc);
}

class ChatDetailEditLastMessagesEvent extends ChatDetailEvent {}

class ChatDetailResetEditOrReplyEvent extends ChatDetailEvent {}

class ChatDetailSendReactionMessagesEvent extends ChatDetailEvent {
  Map<String, dynamic> doc;
  int value;
  ChatDetailSendReactionMessagesEvent(this.doc, this.value);
}

class ChatDetailUnsendReactionMessagesEvent extends ChatDetailEvent {
  Map<String, dynamic> doc;
  ChatDetailUnsendReactionMessagesEvent(this.doc);
}

class ChatDetailCopyMessageEvent extends ChatDetailEvent {
  final String text;

  const ChatDetailCopyMessageEvent(this.text);
}

class ChatDetailPastTextInputEvent extends ChatDetailEvent {
  final String? text;

  const ChatDetailPastTextInputEvent(this.text);
}

class ChatDetailUpdateSentAppointmentStateEvent extends ChatDetailEvent {
  bool enableSentAppointment;
  ChatDetailUpdateSentAppointmentStateEvent(this.enableSentAppointment);
}

class ChatDetailSentAppointmentEvent extends ChatDetailEvent {
  DateTime datetime;
  HomelidoProperty property;
  ChatDetailSentAppointmentEvent(this.datetime, this.property);
}

class ChatDetailRefreshMeetingStateEvent extends ChatDetailEvent {}
