import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:get/get.dart';
import 'package:_private_core/_private_core.dart';
import 'package:_private_core/widgets/widgets.dart';

import '../bloc/chat_detail_bloc.dart';

class WidgetMoreButtonChat extends StatefulWidget {
  const WidgetMoreButtonChat({Key? key}) : super(key: key);

  @override
  _WidgetMoreButtonChatState createState() => _WidgetMoreButtonChatState();
}

class _WidgetMoreButtonChatState extends State<WidgetMoreButtonChat> {
  bool get isEnableNotification => false;

  Color get textColor => hexColor('#869AB5');

  @override
  Widget build(BuildContext context) {
    return WidgetOverlayActions(
      child: const Padding(
        padding: EdgeInsets.symmetric(horizontal: 16, vertical: 10),
        child: Icon(
          Icons.more_horiz,
          color: Colors.white,
          size: 34,
        ),
      ),
      builder:
          (child, size, position, rightClickPosition, animationValue, hide) {
        bool isLeftSide = true;
        if (position.dx - 110 <= 0) isLeftSide = false;
        return Positioned(
          right: 20,
          top: position.dy + 45,
          child: Container(
            padding: const EdgeInsets.symmetric(horizontal: 12),
            child: Column(
              children: [
                _buildButton(
                    context: context,
                    hideMenu: hide,
                    index: 1,
                    isLeftSide: isLeftSide,
                    color: textColor,
                    onTap: () {
                      // ChatHelper.setNotificationChat(
                      //     peer: widget.info[Dbkeys.phone],
                      //     enableNotification: !isEnableNotification);
                    },
                    icon: !isEnableNotification
                        ? Icons.notifications_none_rounded
                        : Icons.notifications_off_rounded,
                    label: isEnableNotification
                        ? 'slientnotifications'
                        : 'slientnotifications'),
                _buildButton(
                    context: context,
                    hideMenu: hide,
                    index: 2,
                    isLeftSide: isLeftSide,
                    color: textColor,
                    onTap: () {
                      // ChatHelper.setNotificationChat(
                      //     peer: widget.info[Dbkeys.phone],
                      //     enableNotification: !isEnableNotification);
                    },
                    icon: Icons.block,
                    label: 'block'),
                // _buildButton(
                //     context: context,
                //     hideMenu: hideMenu,
                //     index: 3,
                //     isLeftSide: isLeftSide,
                //     color: textColor,
                //     onTap: () {
                //       // ChatHelper.setNotificationChat(
                //       //     peer: widget.info[Dbkeys.phone],
                //       //     enableNotification: !isEnableNotification);
                //     },
                //     icon: Icons.event,
                //     label: 'sendappointment'),
                if (!appPrefs.loginUser.isUserVersion &&
                    appPrefs.loginUser!.isHomelidoAgent == 1)
                  _buildButton(
                      context: context,
                      hideMenu: hide,
                      index: 3,
                      isLeftSide: isLeftSide,
                      color: textColor,
                      onTap: () {
                        Get.find().add(
                            ChatDetailUpdateSentAppointmentStateEvent(true));
                      },
                      icon: Icons.event,
                      label: 'sendappointment'),
                _buildButton(
                    context: context,
                    hideMenu: hide,
                    index: 4,
                    isLeftSide: isLeftSide,
                    color: textColor,
                    onTap: () {
                      // ChatHelper.setNotificationChat(
                      //     peer: widget.info[Dbkeys.phone],
                      //     enableNotification: !isEnableNotification);
                    },
                    icon: Icons.location_on,
                    label: 'sendtheactuallocation'),
              ],
            ),
          ),
        );
      },
    );
  }
}

Widget _buildButton(
    {onTap,
    required context,
    required icon,
    required hideMenu,
    required String label,
    String label2 = '',
    Color? color,
    required bool isLeftSide,
    required index}) {
  Widget child = GestureDetector(
    onTap: () {
      hideMenu.call();
      HapticFeedback.mediumImpact();
      onTap?.call();
    },
    child: Stack(
      alignment: Alignment.centerRight,
      clipBehavior: Clip.none,
      children: [
        if (isLeftSide)
          Positioned(
            right: 65,
            child: Text(
              label.tr + label2,
              style: textStyleSmall.copyWith(color: appColors.textDark2),
            ),
          ),
        CircleAvatar(
          backgroundColor: appColors.element,
          radius: 25,
          child: icon is IconData ? Icon(icon, color: color) : icon,
        ),
        if (!isLeftSide)
          Positioned(
            left: 65,
            child: Text(
              label.tr + label2,
              style: textStyleSmall.copyWith(color: appColors.textDark2),
            ),
          )
      ],
    ),
  );
  return Padding(
    padding: const EdgeInsets.symmetric(vertical: 5),
    child: WidgetAnimationStaggeredItem(
      index: index,
      type: isLeftSide
          ? AnimationStaggeredType.rightToLeft
          : AnimationStaggeredType.leftToRight,
      duration: const Duration(milliseconds: 350),
      child: child,
    ),
  );
}
