import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:get/get.dart';
import 'package:_private_chat/_private_chat.dart';
import 'package:_private_core/_private_core.dart';

class WidgetUserReceivedStatusBuilder extends StatelessWidget {
  final Widget Function(int personalReceived) builder;
  final String id;
  const WidgetUserReceivedStatusBuilder({
    Key? key,
    required this.id,
    required this.builder,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<ConnectionStatusBloc, ConnectionStatusState>(
      bloc: Get.find<ConnectionStatusBloc>(),
      buildWhen: (previous, current) {
        return previous.connectionStatusByKeys[id]?[DB_KEY_PERSONAL_RECEIVED] !=
            current.connectionStatusByKeys[id]?[DB_KEY_PERSONAL_RECEIVED];
      },
      builder: (_, state) {
        return builder(
          state.connectionStatusByKeys[id]?[DB_KEY_PERSONAL_RECEIVED] ?? 0,
        );
      },
    );
  }
}
