import 'package:flutter/material.dart';
import 'package:get/get.dart';

class WidgetDragToBack extends StatelessWidget {
  final Function()? callback;
  final Widget child;
  WidgetDragToBack({Key? key, this.callback, required this.child}) : super(key: key);

  double _dx = 0.0;
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onHorizontalDragStart: (detail) {
        _dx = detail.globalPosition.dx;
      },
      onHorizontalDragUpdate: (details) {
        if (_dx < (details.globalPosition.dx - Get.width / 5)) {
          if (callback != null)
            callback!();
          else
            Get.back();
        }
      },
      child: child,
    );
  }
}
